#delimit;

*** COLLAPSE TO THE EXAM/THETA LEVEL AND SAVE DATASET TO USE FOR MAIN RESULTS;

*** SOME OF THE NY ELA EXAMS HAVE DIFFERENT WEIGHTS FOR SOME QUESTIONS, AS DENOTED BY THE VARIABLE raw_wgt
*** FOR ALL OTHER STATES, SET raw_wgt=1;

capture confirm variable raw_wgt;
if _rc~=0 gen raw_wgt=1;
gen b_dev=(b-theta)^2;

*** COLLAPSE TO THETA/QUESTION LEVEL TO COMPUTE EXPECTED VALUES CONDITIONAL ON THETA;

collapse a b b_dev c u p dp prof_return tau scale prof raw aw raw_wgt, by(yr subj grade theta item) fast;

gen d_prof=dp*prof_return;
gen I =dp^2/(p*(1-p));

*** COLLAPSE TO THETA LEVEL SUMMING ACROSS QUESTIONS;

global sumlist  d_prof I;
global meanlist a b b_dev c u p dp prof_return;

foreach v in $sumlist $meanlist {; replace `v'=`v'*raw_wgt;};

collapse (sum) $sumlist $meanlist raw_wgt (mean) tau scale prof raw aw, by(yr subj grade theta) fast;

gen sem=1/sqrt(I);

foreach v in $meanlist {; replace `v'=`v'/raw_wgt;};
rename raw_wgt Q;

replace b_dev=sqrt(b_dev);

by yr subj grade: egen tot_aw=total(aw);
replace aw=aw/tot_aw*10; drop tot_aw;

gen st="$state";
order st yr subj grade theta;
sort  st yr subj grade theta;
compress;
save $res/${state}_results_bytheta, replace;
